﻿/*
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 * 
 * Title: TweetBrando
 * Version: 0.9.6b
 * Author: Brandon Soucie
 * 
 * Description: A Twitter application for Windows. Built using the Twitterizer
 *              Framework library to access the Twitter API.
 *              
 * Created: August 7, 2009
 * Modified: August 10, 2009
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 */

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Twitterizer.Framework;

namespace TweetBrando
{
    public partial class Form1 : Form
    {
        public static string username;
        public static string password;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            cMenuQuit.Click += new EventHandler(cMenuQuit_Click);
            cMenuFriendsTimeline.CheckedChanged += new EventHandler(cMenuFriendsTimeline_CheckedChanged);
            cMenuTrending.Click += new EventHandler(cMenuTrending_Click);
            bLogin.Click += new EventHandler(bLogin_Click);
            bStatusUpdate.Click += new EventHandler(bStatusUpdate_Click);
            tPassword.KeyDown += new KeyEventHandler(tPassword_KeyDown);
            tUpdateStatus.KeyDown += new KeyEventHandler(tUpdateStatus_KeyDown);
        }

        private void cMenuTrending_Click(object sender, EventArgs e)
        {
            TrendingTopics tt = new TrendingTopics();
            tt.Show();
        }

        private void cMenuFriendsTimeline_CheckedChanged(object sender, EventArgs e)
        {
            FriendTimeline ft = new FriendTimeline();

            if (cMenuFriendsTimeline.Checked == true)
            {
                ft.Show();
            }
            else
            {
                try
                {
                    FriendTimeline ft2 = (FriendTimeline)Application.OpenForms["FriendTimeline"];
                    ft2.Close();
                }
                catch { }
            }
        }

        private void tPassword_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
                this.bLogin_Click(sender,e);
        }

        private void tUpdateStatus_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
                this.bStatusUpdate_Click(sender, e);
        }

        private void bLogin_Click(object sender, EventArgs e)
        {
            //Set easier variable names to work with.
            username = tUsername.Text;
            password = tPassword.Text;

            //Clear text fields.
            tUsername.Text = "";
            tPassword.Text = "";

            try
            {
                Twitter tweeter = new Twitter(username, password, "TweetBrando");
                TwitterStatusCollection myTweets = tweeter.Status.UserTimeline();
                TwitterStatusCollection friendTweets = tweeter.Status.FriendsTimeline();
                TwitterStatusCollection atTweets = tweeter.Status.Replies();

                cMenuFriendsTimeline_CheckedChanged(sender, e);
                pUserPicture.ImageLocation = myTweets[0].TwitterUser.ProfileImageUri;
                tUserStatus.Text = myTweets[0].Text;
                lAtUser.Text = "@"+username.ToLower();
                pTiny1.ImageLocation = atTweets[0].TwitterUser.ProfileImageUri;
                pTiny2.ImageLocation = atTweets[1].TwitterUser.ProfileImageUri;
                pTiny3.ImageLocation = atTweets[2].TwitterUser.ProfileImageUri;
                pTiny4.ImageLocation = atTweets[3].TwitterUser.ProfileImageUri;
                lReply1.Text = atTweets[0].Text;
                lReply2.Text = atTweets[1].Text;
                lReply3.Text = atTweets[2].Text;
                lReply4.Text = atTweets[3].Text;

                pDivider2.Visible = true;
                tUpdateStatus.Visible = true;
                bStatusUpdate.Visible = true;
                pUserPicture.Visible = true;
                tUserStatus.Visible = true;
                lAtUser.Visible = true;
                lReply1.Visible = true;
                lReply2.Visible = true;
                lReply3.Visible = true;
                lReply4.Visible = true;
                pTiny1.Visible = true;
                pTiny2.Visible = true;
                pTiny3.Visible = true;
                pTiny4.Visible = true;

                cMenuFriendsTimeline.Enabled = true;

            }
            catch
            {
                MessageBox.Show("There was a problem logging you into Twitter.\nPlease try again.","Login Error!",MessageBoxButtons.OK,MessageBoxIcon.Error);
            }
        }

        private void bStatusUpdate_Click(object sender, EventArgs e)
        {
            Twitter tweeter = new Twitter(username, password, "TweetBrando");

            if (tUpdateStatus.Text == "")
                MessageBox.Show("You didn't enter a status!", "Status Error!", MessageBoxButtons.OK, MessageBoxIcon.Error);
            else
            {
                try
                {
                    tweeter.Status.Update(tUpdateStatus.Text);
                    tUpdateStatus.Text = "";
                    doRefresh();
                }
                catch
                {
                    MessageBox.Show("There was an error updating your status.\nPlease try again.", "Status Error!", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void doRefresh()
        {
            Twitter tweeter = new Twitter(username, password, "TweetBrando");

            try
            {
                TwitterStatusCollection myTweets = tweeter.Status.UserTimeline();
                TwitterStatusCollection friendTweets = tweeter.Status.FriendsTimeline();
                TwitterStatusCollection atTweets = tweeter.Status.Replies();

                pUserPicture.ImageLocation = myTweets[0].TwitterUser.ProfileImageUri;
                tUserStatus.Text = myTweets[0].Text;
                lAtUser.Text = "@" + username.ToLower();
                pTiny1.ImageLocation = atTweets[0].TwitterUser.ProfileImageUri;
                pTiny2.ImageLocation = atTweets[1].TwitterUser.ProfileImageUri;
                pTiny3.ImageLocation = atTweets[2].TwitterUser.ProfileImageUri;
                pTiny4.ImageLocation = atTweets[3].TwitterUser.ProfileImageUri;
                lReply1.Text = atTweets[0].Text;
                lReply2.Text = atTweets[1].Text;
                lReply3.Text = atTweets[2].Text;
                lReply4.Text = atTweets[3].Text;
            }
            catch
            {
                MessageBox.Show("There was an error refreshing your statuses.\nMake sure you are connected to the internet and have not reached your rate limit.", "Refresh Error!", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void cMenuQuit_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
