﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Web;
using System.Web.Script;
using System.Web.Script.Serialization;
using System.Net;
using System.IO;

namespace TweetBrando
{
    public partial class TrendingTopics : Form
    {
        public TrendingTopics()
        {
            InitializeComponent();
        }

        private void TrendingTopics_Load(object sender, EventArgs e)
        {
            try
            {
                Trends[] topics = getTrendingTopics();

                if (topics == null)
                    this.Close();

                foreach (Trends i in topics)
                {
                    listTrends.Items.Add(i.name);
                }
            }
            catch
            {
                MessageBox.Show("There was an error!");
                this.Close();
            }

            bViewTopic.Click += new EventHandler(bViewTopic_Click);
        }

        private void bViewTopic_Click(object sender, EventArgs e)
        {
            string selected_topic = listTrends.Items[listTrends.SelectedIndex].ToString();
            TrendingView tw = new TrendingView(selected_topic);
            tw.Show();
            
        }

        public Trends[] getTrendingTopics()
        {
            string url = @"http://search.twitter.com/trends.json";
            //string file = @"C:\Documents and Settings\Brando\Desktop\poopy.txt";
            string tempstring = null;
            int count = 0;

            StringBuilder sb = new StringBuilder();
            byte[] buf = new byte[9000];

            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(url);
            HttpWebResponse resp = (HttpWebResponse)req.GetResponse();
            Stream respStream = resp.GetResponseStream();

            do
            {
                count = respStream.Read(buf, 0, buf.Length);

                if (count != 0)
                {
                    tempstring = Encoding.ASCII.GetString(buf, 0, count);
                    sb.Append(tempstring);
                }
            } while (count > 0);

            string jSON = sb.ToString();

            JavaScriptSerializer deser = new JavaScriptSerializer();
            Trending tt = deser.Deserialize<Trending>(jSON);

            respStream.Close();

            return tt.trends;
        }
    }

    public class Trending
    {
        public string as_of { get; set; }
        public Trends[] trends { get; set; }
    }

    public class Trends
    {
        public string name { get; set; }
        public string url { get; set; }
    }
}
